<?php

namespace FiloBlu\Hotfix\Plugin;

/**
 * Class CheckoutCartid
 * @package FiloBlu\Hotfix\Plugin
 */
class CheckoutCartid
{

    /**
     * @param \Magento\Webapi\Controller\Rest\ParamsOverrider $ParamsOverrider
     * @param \Closure $proceed
     * @param array $inputData
     * @param array $parameters
     * @return mixed
     */
    public function aroundoverride(\Magento\Webapi\Controller\Rest\ParamsOverrider $ParamsOverrider, \Closure $proceed, array $inputData, array $parameters)
    {
        //preserve the coupon code functionality
        if (isset($inputData['cartId']) && $inputData['cartId'] !== 'mine' && (!isset($inputData['couponCode']) || !isset($inputData['coupon_code']))) {
            $cartId = $inputData['cartId'];
        }
        $result = $proceed($inputData, $parameters);
        if (isset($cartId) && $inputData['cartId'] !== 'mine') {
            $result['cartId'] = $cartId;
        }
        return $result;
    }

}
